package github.benjamin.equipreservebackend.vo;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import github.benjamin.equipreservebackend.entity.Device;
import github.benjamin.equipreservebackend.entity.Reservation;
import github.benjamin.equipreservebackend.entity.User;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class ReservationVO {

    @JsonSerialize(using = ToStringSerializer.class)
    private Long reservationId;
    private String applicantName;
    private String applicantTeam;
    private String applicantContact;
    @JsonSerialize(using = ToStringSerializer.class)
    private Long deviceId;
    private String deviceName;
    private LocalDate startTime;
    private LocalDate endTime;

    public ReservationVO(Reservation r, Device d) {
        this.reservationId = r.getId();
        this.applicantName = r.getApplicantName();
        this.applicantTeam = r.getApplicantTeam();
        this.applicantContact = r.getApplicantContact();
        this.deviceId = d.getId();
        this.deviceName = d.getName();
        this.startTime = r.getStartTime();
        this.endTime = r.getEndTime();
    }

}
